package com.bjsxt.commons;

import org.apache.taglibs.standard.lang.jstl.GreaterThanOperator;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ResourceBundle;

//存放工具类
public class JdbcUtils {
    //提供JDBC的connection的获取和关闭
    private static String driver;
    private static String url;
    private static String username;
    private static String password;
    static {
        try {
        ResourceBundle bundle = ResourceBundle.getBundle("db");//给配置文件的名字
        //读出key，然后赋值
        driver = bundle.getString("jdbc.driver");
        url = bundle.getString("jdbc.url");
        username = bundle.getString("jdbc.username");
        password = bundle.getString("jdbc.password");
        Class.forName(driver);//加载数据库驱动
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
    }

    //获取链接的方法(getConnection方法返回Connection)
    public static Connection getConnection(){
        Connection conn = null;
        try{
            conn = DriverManager.getConnection(url,username,password);
        }catch (Exception e){
            e.printStackTrace();
        }
        return conn;
    }

    //关闭链接的方法
    public static void closeConnection(Connection conn){
        try {
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
