package com.bjsxt.web.servlet;

import com.bjsxt.commons.Constants;
import com.bjsxt.exception.UserNotFoundException;
import com.bjsxt.pojo.Users;
import com.bjsxt.service.Impl.UserLoginServiceImpl;
import com.bjsxt.service.UserLoginService;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;

//处理用户登录请求
@WebServlet(urlPatterns = {"/login.do"})
public class UserLoginServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        //处理用户登录请求，当用户点击提交时，拿取login.jsp里的用户名和密码
        String username = req.getParameter("username");
        String userpwd = req.getParameter("userpwd");
        //拿到账号密码后，调用业务层用户登录的方法完成用户登录处理
        try{
            //创建业务层对象
            UserLoginService userLoginService = new UserLoginServiceImpl();//通过此对象调用业务层接口方法
            Users users = userLoginService.userLogin(username, userpwd);
            HttpSession session = req.getSession();//建立客户端和服务端会话状态
            session.setAttribute(Constants.USER_SESSION_KEY,users);
            //跳转首页-基于重定向方式（可以改变地址栏URL）
            //登录成功后，应该显示首页，而不是登录界面的URL，所以用重定向
            resp.sendRedirect("main.jsp");//登录成功，跳转到main.jsp首页
        }catch (UserNotFoundException e){//如果查无此用户，登录失败，抛出异常
            req.setAttribute("msg",e.getMessage());//拿登录失败的提示信息
            req.getRequestDispatcher("login.jsp").forward(req,resp);//请求转发
        }catch (Exception e){//此处为防止其他异常出现，导致客户端显示http500，即服务器处理异常
            resp.sendRedirect("error.jsp");//无信息传递
        }
    }
}
